#include <nds.h>
#include "ini.h"
#include "cGLMetaseq_nds.h"

float rotateX = 0.0;
float rotateY = 0.0;
float lookposX = 0.0 ;
float lookposY = 0.0 ;
float lookposZ = 9.0 ;
texturePool *texpool ;
cGLMetaseq *meta = NULL ;

// 3D\֌W̏
void init3D(bool useWallpaper) {
	glInit() ;
	glEnable(GL_TEXTURE_2D) ;
	glEnable(GL_BLEND);
	glEnable(GL_ANTIALIAS) ;
	
	glClearColor(0,0,0,(useWallpaper)?0:31) ;//obNɃrbg}bv`悷Ƃ͓߂ɂ
	glClearPolyID(63) ;
	glClearDepth(0x7FFF) ;
	
	glViewport(0,0,255,191) ;
	
	glMatrixMode(GL_PROJECTION) ;
	glLoadIdentity() ;
	gluPerspective(70,256.0/192.0, 0.1, 40) ;
	//(gluLookAt->videoGL.h)̂ȂGL_MODELVIEWɂčsĂ
	gluLookAt(	0.0, 0.0, 9.0,		//camera possition 
				0.0, 0.0, 0.0,		//look at
				0.0, 1.0, 0.0);		//up
	glMatrixMode(GL_MODELVIEW);
	texpool = new texturePool(g_textureSize) ;
	cGLMetaseqParent metap(texpool) ;
	if( g_renban ) {
		meta = metap.makeGLMetaseq(true,
				g_renbanfilehead,
				g_renbanform,
				g_renbanstart, g_renbanend, g_renbanstep,
				NULL,&g_scale) ;
	}
	else {
		meta = metap.makeGLMetaseq(true,g_filename,NULL,&g_scale) ;
	}
	if( meta == NULL ) {
		iprintf("mqo read error[%s]\n",
				(g_renban)?g_renbanfilehead:g_filename) ;
	}
}
int a = 0 ;
size_t frame=0 ;
size_t frameUp3D() {
	frame++ ;
	if( meta->getFrameNum() <= frame ) frame=0 ;
	return frame ;
}
void view3DChange(u16 keys) {
	if( !((keys & KEY_R)
		||(keys & KEY_L)
		||(keys & KEY_A)
		||(keys & KEY_B)
		||(keys & KEY_X)
		||(keys & KEY_Y)
						)) return ;
	if((keys & KEY_R)) {
		lookposZ+=0.1;
	}
	if((keys & KEY_L)) {
		lookposZ-=0.1;
	}
	if((keys & KEY_A)) {
		lookposX+=0.1;
	}
	if((keys & KEY_Y)) {
		lookposX-=0.1;
	}
	if((keys & KEY_X)) {
		lookposY+=0.1;
	}
	if((keys & KEY_B)) {
		lookposY-=0.1;
	}
	
	//gluLookAt access GL_MODELVIEW -->videoGL.h
	//gluLookAtԂύXƂgluLookAtĂԑO
	//glMatrixMode(GL_MODELVIEW);glLoadIdentity();
	//ȂƂȂB
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity() ;

	glViewport(0,0,255,191) ;
	
	glMatrixMode(GL_PROJECTION) ;
	glLoadIdentity() ;
	gluPerspective(70,256.0/192.0, 0.1, 40) ;
	gluLookAt(	lookposX, lookposY, lookposZ,		//camera possition 
				lookposX, lookposY, 0.0,		//look at
				0.0, 1.0, 0.0);		//up
}
size_t drow3D(u16 keys) {
	size_t drowframe;
	drowframe = frame ;

	view3DChange(keys) ;

	glPushMatrix();
	
	if((keys & KEY_UP)) rotateX += 3;
	if((keys & KEY_DOWN)) rotateX -= 3;
	if((keys & KEY_LEFT)) rotateY -= 3;
	if((keys & KEY_RIGHT)) rotateY += 3;
	glRotateX(rotateX);
	glRotateY(rotateY);
	
	glMatrixMode(GL_MODELVIEW);
	//not a real gl function and will likely change
	glPolyFmt(POLY_ALPHA(31) | POLY_CULL_BACK 
		| POLY_FORMAT_LIGHT0 //| POLY_FORMAT_LIGHT1 
//		| POLY_FORMAT_LIGHT2 | POLY_FORMAT_LIGHT3 
		) ;
	glLight(0, RGB15(31,31,31) , 0,				  floattov10(-1.0),		 0);
/*
	glLight(0, RGB15(31,31,31) , 0,				  floattov10(-1.0),		 0);
	glLight(1, RGB15(31,0,31),   0,				  floattov10(1) - 1,			 0);
	glLight(2, RGB15(0,31,0) ,   floattov10(-1.0), 0,					 0);
	glLight(3, RGB15(0,0,31) ,   floattov10(1.0) - 1,  0,					 0);
 */


	//draw the obj
	if( meta != NULL ) {
		meta->render(drowframe) ;
	}

	glPopMatrix(1);
	glFlush(GL_WBUFFERING);


	return drowframe;
}
void info3D() {
	if( meta != NULL ) {
		const GLfloat *max,*min ;
		max = meta->getMaxPoint() ;
		iprintf("\x1b[6;0Hmax[%d   %d   %d]    \n",(int)max[0],(int)max[1],(int)max[2]);
		min = meta->getMinPoint() ;
		iprintf("\x1b[7;0Hmin[%d   %d   %d]    \n",(int)min[0],(int)min[1],(int)min[2]);
	}
	iprintf("\x1b[11;0Hlookpos = [%d][%d][%d]        \n",
			(int)lookposX,(int)lookposY,(int)lookposZ);
	iprintf("\x1b[12;0Hrotate = [%d, %d]          \n", (int)rotateX, (int)rotateY);
}
